using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

namespace AT{
    namespace UBF{
        namespace Behaviors{

            /** Example Behavior that uses the Messages/Communication system.
             */
            public class GoodAgent_SendEnemyLocation : AT.UBF.Behavior {
                protected override AT.UBF.Action genActionInternal(AT.UBF.State state){
                    AT.UBF.Action action = new AT.UBF.Action();
					int visibleCount = state.visibleEnemyTanks.Count;
					int i = 0;
					bool visibleEnemy = false;
					
					while(i < visibleCount && visibleEnemy == false){
						AT.Team targetTeam = state.visibleEnemyTanks [i].getTeam();
						if(targetTeam != state.self.getTeam()){      
							visibleEnemy = true;
							Vector2 targetPos = state.visibleEnemyTanks[i].getPosition(); 
							string targetMsg = "T_"+targetPos.x+"_"+targetPos.y;
							string sender = state.self.getColor();
							string myTeam = state.self.getTeam().ToString(); // enum to string representation
							AT.Message msg = new AT.Message(voteSourceID, sender, AT.Message.ReceiverType.Team, myTeam, targetMsg);
							AT.Tank.SendMessage(msg);
						}
						i++;
                    }				
                    return action;
                }
            }
        }
    }
}